#include <sndfile.h>
#include <stdio.h>
#include <stdlib.h>

SNDFILE *pcmopen(char *filename, long size, int samplerate, int channels) 
{
  SF_INFO info;
  SNDFILE *out;
  long total = 0;

  info.format = SF_FORMAT_WAV | SF_FORMAT_PCM_32;
  info.frames = size;
  info.samplerate = samplerate;
  info.channels = channels;
  info.sections = 1;
  info.seekable = 0;

  if (!sf_format_check(&info))
    info.format = (info.format & SF_FORMAT_TYPEMASK);

  out = sf_open(filename, SFM_WRITE, &info);

  if (!sf_format_check(&info)) 
    perror("bad formatfor writing pcm");
  if (!out)
    perror("cannot open file for writing");

  return out;
}

void pcmwrite(SNDFILE *out, float *data, long n) {
  sf_writef_float(out, (float *)data, n);
}

void pcmclose(SNDFILE *out) {
  sf_close(out);
}

int main(int argc, char **argv) {
  float data[1];
  long size = 0;
  FILE *in;
  SNDFILE *out;

  in = fopen(argv[1],"r");
  while( fscanf(in, "%g\n", data) != EOF )
    size++;
  out = pcmopen(argv[2],size,atoi(argv[3]),1);
  fclose(in);

  in = fopen(argv[1],"r");
  while( fscanf(in, "%g\n", data) != EOF )
    pcmwrite(out,data,1);
      
  pcmclose(out);
}
